<template>
  <div
    class="fr-input-group"
    :class="{ 'fr-input-group--error': error }"
  >
    <label
      class="fr-label"
      :class="[labelIcon]"
      :for="name"
    >
      {{ displayLabel }}
      <span
        v-if="hint"
        class="fr-hint-text"
        ><slot name="hint"></slot
      ></span>
    </label>
    <textarea
      :id="name"
      ref="input"
      v-model="modelValue"
      class="fr-input"
      :class="{ 'fr-input--error': error }"
      :name="name"
      :required="required"
      :aria-describedby="ariaDescribedby"
      @input="onValidate"
      @invalid="onValidate"
    ></textarea>
    <div
      v-if="error"
      :id="errorId"
      class="fr-messages-group"
      aria-live="assertive"
    >
      <p class="fr-message fr-message--error">
        {{ error }}
      </p>
    </div>
  </div>
</template>

<script setup>
  const props = defineProps({
    label: { type: String, required: true },
    name: { type: String, required: true },
    required: { type: Boolean, default: false },
    value: { type: String, default: '' },
    hint: { type: Boolean, default: false },
    labelIcon: { type: String, default: '' }
  })

  const error = ref('')

  // This model is only used to prevent first user input character from being removed
  const modelValue = ref(props.value)

  const errorId = computed(() => `${props.name}-error-desc-error`)
  const displayLabel = computed(() =>
    props.required ? `${props.label} *` : props.label
  )
  const ariaDescribedby = computed(() =>
    error.value ? errorId.value : undefined
  )

  function onValidate({ target }) {
    error.value = target.validationMessage
  }
</script>

<style scoped>
  .large-textarea .fr-input {
    /* Pour agrandir la hauteur d'un textarea - Usage HTML : <AtomTextarea class="large-textarea" */
    height: 30rem;
  }
</style>
